# Contributing to Oat++

Thank you for your interest in the project, and for taking time to contribute.  

## How to contribute

All kind of contributions are very welcome.

### Join the community

- Join discussion on **Gitter**. [oat++ framework/Lobby](https://gitter.im/oatpp-framework/Lobby)
- Follow us on **Twitter** for latest news. [@oatpp_io](https://twitter.com/oatpp_io)
- Join community on **Reddit**. [r/oatpp](https://www.reddit.com/r/oatpp/)

### Try to use Oat++

- Grab example project from the [list of examples](https://github.com/oatpp/oatpp-examples)
- Take starter project and try to build something on top of it
  - [Starter project with Simple API](https://github.com/oatpp/oatpp-starter)
  - [Starter project with Async API](https://github.com/oatpp/oatpp-starter-async)
- Try to reproduce benchmark results [2M WebSockets](https://github.com/oatpp/benchmark-websocket)

### Open an issue

Ask question or report a bug [here](https://github.com/oatpp/oatpp/issues)

### Create a pull request

All kind of [pull requests](https://github.com/oatpp/oatpp/pulls) are very welcome.
Even if it's just fixing typos, or adding documentation.

*Please make sure your pull requests confirming to overall project code-style.*  
*Please make sure to notify the community if you are working on an issue so we don't duplicate work!*

### Create Oat++ extension module

Use [oatpp-starter-module](https://github.com/oatpp/oatpp-starter-module) to create oatpp extensions.

## Code of Conduct

Please follow [Code of Conduct](CODE_OF_CONDUCT.md) at all times.  
Please report unacceptable behavior to oatpp.io@gmail.com.
